# HG changeset patch
# User Jim Unroe <rock.unroe@gmail.com>
# Date 1636159567 14400
#      Fri Nov 05 20:46:07 2021 -0400
# Node ID d738d54a19e549c8f0c48f22c4b995df2fd35502
# Parent  13ba0a417aff049773106098160896a20af0da2f
[KT-8R] Settings tab empty for QYT KT-8R

The Settings tabs in CHIRP are empty when the KT-8R has TMR set to M+ABCD.
This driver was derived from the QYT mobile radios which only have 15 TMR
selections. This radio has a 16 TMR selections similar to the BTech mobile
radios so so setting it to the 16th choice puts it out-of-range based on the
current programming.

This patch adds 16 TMR choices support for the QyT KT-8R.

Fixes #9051

diff -r 13ba0a417aff -r d738d54a19e5 chirp/drivers/btech.py
--- a/chirp/drivers/btech.py	Thu Nov 04 17:23:38 2021 -0700
+++ b/chirp/drivers/btech.py	Fri Nov 05 20:46:07 2021 -0400
@@ -4693,7 +4693,7 @@
     VENDOR = "QYT"
     MODEL = "KT-8R"
     BANDS = 4
-    LIST_TMR = LIST_TMR15
+    LIST_TMR = LIST_TMR16
     _vhf_range = (136000000, 175000000)
     _220_range = (200000000, 261000000)
     _uhf_range = (400000000, 481000000)